unit pmatchu;

// Copyright (c) 1999 by Ziff-Davis, Inc.
// Written by Neil J. Rubenking

interface
USES Windows, SysUtils;
VAR
  HasPathMatchSpec : Boolean;

function PathMatchSpec(FileParam, Spec : String) : Bool;
function MyPathMatchSpec(FileParam, Spec : String) : Bool;

implementation
type
  TPathMatchSpec = function(FileParam, Spec : PAnsiChar) : Bool;
    stdcall;
VAR
  vPathMatchSpec : TPathMatchSpec;
  IsWinNT        : Boolean;
  LibH           : THandle;
  OVI            : TOSVersionInfo;

function MyPathMatchSpec(FileParam, Spec : String) : Bool;
  function MMatch(FName, FSpec : PChar) : Bool;
  begin
    CASE FSpec^ OF
      #0  : Result := FName^ = #0;
      '?' : Result := MMatch(FName+1, FSpec+1);
      '*' : REPEAT
              Result := MMatch(FName, FSpec+1);
              IF Result THEN Break;
              IF FName[0]=#0 THEN Break;
              FName := FName + 1;
            UNTIL False;
      ELSE IF FName^ = FSpec^ THEN
        Result := MMatch(FName+1, FSpec+1)
      ELSE Result := False;
    END;
  end;
begin
  IF Pos('.', FileParam) = 0 THEN FileParam := FileParam + '.';
  Result:= MMatch(PChar(Uppercase(FileParam)),
    PChar(Uppercase(Spec)));
end;

function PathMatchSpec(FileParam, Spec : String) : Bool;
begin
  IF NOT HasPathMatchSpec THEN
    Raise(Exception.Create('PathMatchSpec not available'))
  ELSE Result := vPathMatchSpec(PChar(Fileparam), PChar(Spec));
end;

initialization
  FillChar(OVI, SizeOf(OVI), 0);
  OVI.dwOSVersionInfoSize := SizeOf(OVI);
  GetVersionEx(OVI);
  IsWinNt := OVI.dwPlatformId = VER_PLATFORM_WIN32_NT;

  LibH := LoadLibrary('shlwapi.dll');
  IF LibH <= 32 THEN
    begin
      HasPathMatchSpec := FALSE;
      LibH := 0;
    end
  ELSE
    begin
      IF IsWinNT THEN
        @vPathMatchSpec := GetProcAddress(LibH, 'PathMatchSpecW')
      ELSE
        @vPathMatchSpec := GetProcAddress(LibH, 'PathMatchSpecA');
      IF @vPathMatchSpec = nil THEN
        begin
          HasPathMatchSpec := FALSE;
          FreeLibrary(LibH);
          LibH := 0;
        end
      ELSE HasPathMatchSpec := TRUE;
    end;
finalization
  IF LibH <> 0 THEN
    FreeLibrary(LibH);
end.
